package jogo;

import java.util.ArrayList;

public class ComparadorDeCartas {

    private ArrayList<String> pesoCartaNumero;
    private ArrayList<String> pesoCartaNaipe;
    private String Carta1;
    private String Carta2;
    private String manilha;
    private int resultado;

    public ComparadorDeCartas() {
        this.pesoCartaNumero = new ArrayList<String>();
        this.pesoCartaNaipe = new ArrayList<String>();
    }

    public void CriarTabela() {
        //limpa os arraylists
        this.pesoCartaNaipe.clear();
        this.pesoCartaNumero.clear();
        String naipe = "oecp";
        String frente = "4567djq123";

        for (int i = 0; i < frente.length(); i++) {
            this.pesoCartaNumero.add("" + frente.charAt(i));
        }
        for (int i = 0; i < naipe.length(); i++) {
            this.pesoCartaNaipe.add("" + naipe.charAt(i));
        }
    }

    public void setCarta1(String carta) {
        this.Carta1 = carta;
    }

    public void setCarta2(String carta) {
        this.Carta2 = carta;
    }

    public void cacularCarta(int n) {
        int i = 0;
        int j = 0;

        switch (n) {
            case 0:
                for (int k = 0; k < this.pesoCartaNumero.size(); k++) {
                    //compara a carta do primeiro jogador
                    if (this.pesoCartaNumero.get(k).equals("" + this.Carta1.charAt(0))) {
                        i = k;
                    }
                    //compara a carta do segundo jogador
                    if (this.pesoCartaNumero.get(k).equals("" + this.Carta2.charAt(0))) {
                        j = k;
                    }
                }
                break;
            case 1:
                for (int k = 0; k < this.pesoCartaNaipe.size(); k++) {
                    //percorre ate a posicao da carta do jogador 1
                    if (this.pesoCartaNaipe.get(k).equals("" + this.Carta1.charAt(1))) {
                        i = k;
                        //percorre ate a posicao da carta do jogador 2
                    }
                    if (this.pesoCartaNaipe.get(k).equals("" + this.Carta2.charAt(1))) {
                        j = k;
                    }
                }
                break;
        }
        //comparacao das cartas, i > j: primeiro jogador vence, i < j: segundo jogador vence, i = j: empate
        if (i > j) {
            resultado = 1;
        } else if (i < j) {
            resultado = 2;
        } else if (i == j) {
            resultado = 3;
        }
    }

    public int getCalculaCarta() {
        return this.resultado;
    }

    public void setManilha(String manilha) {
        this.manilha = manilha;
        this.trocaDePosicaoCuringa();
    }

    //troca a posicao do coringa
    private void trocaDePosicaoCuringa() {
        String carComp;
        for (int i = 0; i < this.pesoCartaNumero.size(); i++) {
            if (this.pesoCartaNumero.get(i).equals("" + this.manilha.charAt(0)) && i < this.pesoCartaNumero.size() - 1) {
                carComp = "" + this.pesoCartaNumero.get(i + 1);
                this.pesoCartaNumero.remove(i + 1);
                this.pesoCartaNumero.add(carComp);
                break;
            } else if (i == this.pesoCartaNumero.size() - 1) {
                carComp = "" + this.pesoCartaNumero.get(0);
                this.pesoCartaNumero.remove(0);
                this.pesoCartaNumero.add(carComp);
            }
        }
    }
}
