package jogo;

public class Placar {

    private Principal pai;
    private int rodada = 1;
    private int rodada1;
    private int rodada2;
    private int rodada3;
    private int placarJogador1 = 0;
    private int placarJogador2 = 0;
    private int placarGeralJogador1 = 0;
    private int placarGeralJogador2 = 0;
    private int ganhadorDaPartida = 0;
    private int aposta = 1;
    private int buffer_aposta = 0;
    private boolean comparaPlacar = false;
    private boolean correr = false;

    public Placar(Principal aThis) {
        this.pai = aThis;
    }

    public void setRodada(int rod) {

        if (rodada == 1) {
            this.rodada1 = rod;
        } else if (rodada == 2) {
            this.rodada2 = rod;
            this.placarGeralrod1_2();
        } else if (rodada == 3) {
            this.rodada3 = rod;
            this.placarGeralrod3();
        }
        if (this.rodada <= 3) {
            this.rodada++;
        }
    }

    public void placarGeralrod1_2() {

        //placar da rodada
        int jogador1 = 0;
        int jogador2 = 0;
        switch (this.rodada1) {
            case 1:
                jogador1++;
                break;
            case 2:
                jogador2++;
                break;
        }
        switch (this.rodada2) {
            case 1:
                jogador1++;
                break;
            case 2:
                jogador2++;
                break;
        }

        if (jogador1 != jogador2) {
            this.placardaRodada(jogador1, jogador2);
            this.comparaPlacar = true;
            this.caulculaGanhadorPatida();
        }
    }

    public boolean getcomparaPlacar() {
        return this.comparaPlacar;
    }

    public void setarcomparaPlacar() {
        this.rodada = 1;
        this.rodada1 = 0;
        this.rodada2 = 0;
        this.rodada3 = 0;
        this.aposta = 1;
        this.buffer_aposta = 0;
        this.placarJogador1 = 0;
        this.placarJogador2 = 0;
        this.ganhadorDaPartida = 0;
        this.comparaPlacar = false;
        this.correr = false;
    }

    public void placarGeralrod3() {
        this.comparaPlacar = true;
        switch (this.rodada3) {
            case 1:
                this.placarJogador1++;
                break;
            case 2:
                this.placarJogador2++;
                break;
            case 3:
                if(this.rodada1 == 1){
                    this.placarJogador1++;
                } else if(this.rodada1 == 2){
                    this.placarJogador2++;
                } else if(this.rodada1 == 3 && this.rodada2 ==3){
                    this.pai.calculoNaipe();
                }
                break;
        }
        this.caulculaGanhadorPatida();
    }

    private void placardaRodada(int jogador1, int jogador2) {
        //placar de pontos Geral
        if (jogador1 > jogador2) {
            this.placarJogador1++;
        } else if (jogador1 < jogador2) {
            this.placarJogador2++;
        }
    }

    public int getValorTruco() {
        return this.aposta;
    }

    public void setAposta(int aposta, boolean id) {
        if (aposta == 0) {
            if (this.buffer_aposta == 0) {
                this.aposta = 3;
            } else {
                this.aposta = this.buffer_aposta;
                this.buffer_aposta = 0;
            }
        } else if (aposta == 2) {
            if (this.buffer_aposta == 0) {
                this.aposta = 1;
            } else {
                this.aposta = this.buffer_aposta;
                this.buffer_aposta = 0;
            }
            if (id) {
                this.placarGeralJogador2 += this.aposta;
                this.ganhadorDaPartida = 2;
            } else {
                this.placarGeralJogador1 += this.aposta;
                this.ganhadorDaPartida = 1;
            }
            this.correr = true;
        } else if (aposta % 3 == 0) {
            this.buffer_aposta = aposta;
        }
    }

    public boolean getCorrer() {
        return this.correr;
    }

    public int getPlacarJogador1() {
        return this.placarGeralJogador1;
    }

    public int getPlacarJogador2() {
        return this.placarGeralJogador2;
    }

    public int getGanhadorPartida() {
        return this.ganhadorDaPartida;
    }

    private void caulculaGanhadorPatida() {
        if (this.placarJogador1 > this.placarJogador2) {
            this.placarGeralJogador1 += this.aposta;
            this.ganhadorDaPartida = 1;
        } else if (this.placarJogador1 < this.placarJogador2) {
            this.placarGeralJogador2 += this.aposta;
            this.ganhadorDaPartida = 2;
        }
    }

    public int getRodada() {
        return this.rodada - 1;
    }

    public int getResultadoRodada(int rodada) {
        int i = 0;
        switch (rodada) {
            case 1:
                i = this.rodada1;
                break;
            case 2:
                i = this.rodada2;
                break;
            case 3:
                i = this.rodada3;
                break;
        }
        return i;
    }
}
