/*
 * Principal.java
 *
 * Created on 19/05/2011, 09:44:35
 * License: GPLv3
 */
package jogo;

import java.util.ArrayList;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

/**
 *
 * @author Gustavo Paulo Medeiros da Silva, Murilo Bauer,Emerson Ribeiro de Mello
 */
public class Principal extends javax.swing.JFrame {

    private ArrayList<Carta> baralho;
    private Placar plac;
    private boolean conectado;
    private EsperaConexao servEsp;
    private JogadorThread jt;
    private Carta ca;
    private ComparadorDeCartas Comparar;
    private boolean executado = false;
    private boolean enviar = false;
    private int PontoJogador_truco = 0;
    private boolean minhaVez = false;
    private boolean trucado = false;
    private String carta1;
    private String carta2;
    private int n_y1 = 0;

    /** Creates new form Principal */
    public Principal() {
        this.baralho = new ArrayList<Carta>();
        this.conectado = false;
        initComponents();
        this.setLocationRelativeTo(null);
        this.setTitle("TRUCO MANEIRO");
        this.setIconImage(new ImageIcon(this.getClass().getResource("/resources/cartas/fundocarta.png")).getImage());
    }

    public void desenharBaralho(String cart, boolean id) {
        this.jBDesistirJogo.setEnabled(true);
        this.baralho.clear();
        String[] cartas = cart.split(":");
        for (int i = 0; i < (cartas.length + 3); i++) {
            if (i <= 3) {
                //construtor das cartas do jogador e manilha
                this.ca = new Carta("" + cartas[i] + ".png", i, ((Mesa) this.jPMesa).getAltura(), ((Mesa) this.jPMesa).getLargura(), cartas[i], false);
            }
            if (i > 3) {
                //construtor das cartas que de fundo azul
                this.ca = new Carta("" + "fundocarta" + ".png", i, ((Mesa) this.jPMesa).getAltura(), ((Mesa) this.jPMesa).getLargura(), "fundoa", true);
            }
            this.baralho.add(this.ca);
        }

        if (this.minhaVez) {
            this.jLabel13.setText("É A SUA VEZ!");
            if (this.PontoJogador_truco < 11 && !this.trucado) {
                this.jTrucar.setEnabled(true);
            }
        } else {
            this.jTrucar.setEnabled(false);
            this.jLabel13.setText("É A VEZ DO OPONENTE!");
        }

        //desenha as cartas na mesa /"importante"
        ((Mesa) this.jPMesa).repaint();

    }

    public void desenharCartaOponente(String cartamod, int posCart) {
        this.carta2 = cartamod;
        this.ca = new Carta("" + cartamod + ".png", posCart + 4, ((Mesa) this.jPMesa).getAltura(), ((Mesa) this.jPMesa).getLargura(), cartamod, true);
        this.baralho.set(posCart + 4, ca);
        //desenha as cartas na mesa /"importante"
        ((Mesa) this.jPMesa).repaint();
        this.minhaVez = !this.minhaVez;
        if (this.minhaVez) {
            this.jLabel13.setText("É A SUA VEZ!");
            if (this.PontoJogador_truco < 11 && !this.trucado) {
                this.jTrucar.setEnabled(true);
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPMesa = new Mesa(this, this.baralho);
        jLabel14 = new javax.swing.JLabel();
        jPLateral = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jTrucar = new javax.swing.JButton();
        jBDesistirJogo = new javax.swing.JButton();
        jLabel13 = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JTrucoOO - Jogo de Cartas");
        setBackground(new java.awt.Color(1, 1, 1));
        setResizable(false);

        jPMesa.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel14.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/mesa.png"))); // NOI18N

        javax.swing.GroupLayout jPMesaLayout = new javax.swing.GroupLayout(jPMesa);
        jPMesa.setLayout(jPMesaLayout);
        jPMesaLayout.setHorizontalGroup(
            jPMesaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, 500, Short.MAX_VALUE)
        );
        jPMesaLayout.setVerticalGroup(
            jPMesaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, 450, Short.MAX_VALUE)
        );

        jPLateral.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel1.setText("Jogadores");

        jLabel2.setText("Pontos");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 85, Short.MAX_VALUE)
                .addComponent(jLabel2)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addContainerGap())
        );

        jLabel3.setText("Jogador 1");

        jLabel4.setText("0");

        jLabel5.setText("0");

        jLabel6.setText("Jogador 2");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(20, 20, 20)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 111, Short.MAX_VALUE)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel5))
                .addContainerGap(21, Short.MAX_VALUE))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel7.setText("Rodada 1");

        jLabel8.setText("Rodada 2");

        jLabel9.setText("Rodada 3");

        jLabel10.setText(" ");

        jLabel11.setText(" ");

        jLabel12.setText(" ");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel7)
                    .addComponent(jLabel8)
                    .addComponent(jLabel9))
                .addGap(34, 34, 34)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)
                    .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)
                    .addComponent(jLabel10, javax.swing.GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jLabel10))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel9))
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTrucar.setText("TRUCO");
        jTrucar.setEnabled(false);
        jTrucar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTrucarActionPerformed(evt);
            }
        });

        jBDesistirJogo.setText("CORRER");
        jBDesistirJogo.setEnabled(false);

        javax.swing.GroupLayout jPLateralLayout = new javax.swing.GroupLayout(jPLateral);
        jPLateral.setLayout(jPLateralLayout);
        jPLateralLayout.setHorizontalGroup(
            jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPLateralLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jBDesistirJogo, javax.swing.GroupLayout.DEFAULT_SIZE, 240, Short.MAX_VALUE)
                    .addComponent(jTrucar, javax.swing.GroupLayout.DEFAULT_SIZE, 240, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPLateralLayout.setVerticalGroup(
            jPLateralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPLateralLayout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 135, Short.MAX_VALUE)
                .addComponent(jTrucar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jBDesistirJogo)
                .addContainerGap())
        );

        jMenu1.setText("Jogo");

        jMenuItem3.setText("Conectar");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem3);

        jMenuItem5.setText("Desconectar");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem5);

        jMenuItem4.setText("Sair");
        jMenu1.add(jMenuItem4);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Ajuda");

        jMenuItem1.setText("Manual");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem1);

        jMenuItem2.setText("Sobre");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem2);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(197, 197, 197)
                        .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(jPMesa, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPLateral, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPLateral, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPMesa, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

   private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
       if (this.conectado == false) {
           Conectar conect = new Conectar(this, true);
           conect.setLocationRelativeTo(this);
           conect.setVisible(true);
       } else {
           JOptionPane.showMessageDialog(rootPane, "Você está conectado!", "alerta", JOptionPane.ERROR_MESSAGE);
       }
   }//GEN-LAST:event_jMenuItem3ActionPerformed

   private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
       if (this.conectado == true) {
           Desconectar desconect = new Desconectar(this, true);
           desconect.setLocationRelativeTo(this);
           desconect.setVisible(true);
       } else {
           JOptionPane.showMessageDialog(rootPane, "Você não está conectado!", "alerta", JOptionPane.ERROR_MESSAGE);
       }
   }//GEN-LAST:event_jMenuItem5ActionPerformed

   private void jTrucarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTrucarActionPerformed
       Mensagem pedirTruco = new Mensagem(350, 3, this.jt.getidJogador());
       this.jTrucar.setEnabled(false);
       this.jt.enviarMensagem(pedirTruco);
       this.jLabel13.setText(" VOCÊ PEDIU TRUCO AO OPONENTE!");
   }//GEN-LAST:event_jTrucarActionPerformed

   private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
       Regras regras = new Regras(this, true);
       regras.setLocationRelativeTo(this);
       regras.setVisible(true);
}//GEN-LAST:event_jMenuItem1ActionPerformed

   private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
       Sobre sobre = new Sobre(this, true);
       sobre.setLocationRelativeTo(this);
       sobre.setVisible(true);
   }//GEN-LAST:event_jMenuItem2ActionPerformed
    /**
     */
    //* @param
    //args the command line arguments
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                new Principal().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBDesistirJogo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JPanel jPLateral;
    private javax.swing.JPanel jPMesa;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JButton jTrucar;
    // End of variables declaration//GEN-END:variables

    public void criarJogo(String nome, String IP, int porta) {
        this.servEsp = new EsperaConexao(this, porta);
        this.servEsp.start();
        this.jt = new JogadorThread(this, nome, IP, porta, true);
        this.jt.start();
        this.conectado = true;
        this.Comparar = new ComparadorDeCartas();
        this.Comparar.CriarTabela();
        this.plac = new Placar(this);
        //por default, o jogador que estiver rodando o ServidorThread sera o primeiro a jogar
        this.minhaVez = true;
    }

    public void conectarJogo(String nome, String IP, int porta) {
        this.jt = new JogadorThread(this, nome, IP, porta, false);
        this.jt.start();
        this.conectado = true;
        //o jogador que nao estiver rodando o ServidorThead sera o segundo a jogar
        this.minhaVez = false;
    }

    public void enviarDadosCartas(String nome, int posicaoCarta) {
        this.carta1 = nome;
        this.minhaVez = false;
        this.jTrucar.setEnabled(false);
        Mensagem enviaCarta = new Mensagem(150, nome, posicaoCarta, jt.getidJogador());
        this.jt.enviarMensagem(enviaCarta);
        this.jLabel13.setText("É A VEZ DO OPONENTE!");
        ((Mesa) jPMesa).repaint();
    }

    public void enviarDesconexao() {
        Mensagem desc = new Mensagem(10, "");
        this.jt.enviarMensagem(desc);
    }

    public void desconectar1() {
        JOptionPane.showMessageDialog(rootPane, "O SERVIDOR FOI DESCONECTADO!", "Desconectar", JOptionPane.INFORMATION_MESSAGE);
        this.jLabel3.setText("Jogador 1");
        this.jLabel6.setText("Jogador 2");
        this.jLabel4.setText("0");
        this.jLabel4.setText("0");
        this.baralho.clear();
        ((Mesa) this.jPMesa).repaint();

    }

    public void AumentarAposta(int opcao) {
        int i;
        switch (opcao) {
            case 0:
                JOptionPane.showMessageDialog(rootPane, "O OPONENTE ACEITOU AUMENTAR A APOSTA", "AUMENTAR A APOSTA", JOptionPane.INFORMATION_MESSAGE);
                break;
            case 2:
                JOptionPane.showMessageDialog(rootPane, "O OPONENTE CORREU", "AUMENTAR A APOSTA", JOptionPane.INFORMATION_MESSAGE);
                //reiniciar partida
                Mensagem nova = new Mensagem(300, "");
                this.jt.enviarMensagem(nova);
                break;
            case 3:
                i = this.construirJOptionPane("SEIS", "TRUCO");
                if (i == 1) {
                    i = 6;
                }
                this.enviaMensagem(i);
                break;
            case 6:
                i = this.construirJOptionPane("NOVE", "SEIS");
                if (i == 1) {
                    i = 9;
                }
                this.enviaMensagem(i);
                break;
            case 9:
                i = this.construirJOptionPane("DOSE", "NOVE");
                if (i == 1) {
                    i = 12;
                }
                this.enviaMensagem(i);
                break;
            case 12:
                this.enviaMensagem(this.construirJOptionPane(null, "DOSE"));
                break;
        }
        if (opcao != 2) {
            this.trucado = true;
        }

    }

    private int construirJOptionPane(String a, String b) {
        int i = 0;
        if (a != null) {
            Object[] options1 = {"ACEITAR", a, "CORRER"};
            i = JOptionPane.showOptionDialog(rootPane, "O OPONENTE PEDIU " + b, "AUMENTAR APOSTA", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE,
                    null, options1, options1[0]);
        } else if (a == null) {
            Object[] options2 = {"ACEITAR", "CORRER"};
            i = JOptionPane.showOptionDialog(rootPane, "O OPONENTE PEDIU " + b, "AUMENTAR APOSTA", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE,
                    null, options2, options2[0]);
            if (i == 1) {
                i = 2;
            }

        }
        this.jTrucar.setEnabled(false);
        return i;
    }

    private void enviaMensagem(int i) {
        Mensagem msg = new Mensagem(351, i, this.jt.getidJogador());
        this.jt.enviarMensagem(msg);
    }

    public void setgraficoNome1(String nome) {
        this.jLabel3.setText(nome);
    }

    public void setgraficoNome2(String corpo) {
        this.jLabel6.setText(corpo);
    }

    public void atualizaPlacar(int rodada, int ganhadorRodada, boolean id) {
        try {
            switch (rodada) {
                case 1:
                    if (ganhadorRodada == 1) {
                        this.jLabel10.setText(jLabel3.getText());
                    } else if (ganhadorRodada == 2) {
                        this.jLabel10.setText(jLabel6.getText());
                    } else {
                        this.jLabel10.setText("Empate");
                    }
                    break;
                case 2:
                    if (ganhadorRodada == 1) {
                        this.jLabel11.setText(jLabel3.getText());
                    } else if (ganhadorRodada == 2) {
                        this.jLabel11.setText(jLabel6.getText());
                    } else {
                        this.jLabel11.setText("Empate");
                    }
                    break;
                case 3:
                    if (ganhadorRodada == 1) {
                        this.jLabel12.setText(jLabel3.getText());
                    } else if (ganhadorRodada == 2) {
                        this.jLabel12.setText(jLabel6.getText());
                    }
                    break;
            }
            if (ganhadorRodada == 1) {
                if (id) {
                    this.minhaVez = true;
                    this.jLabel13.setText("É A SUA VEZ!");
                } else {
                    this.minhaVez = false;
                    this.jLabel13.setText("É A VEZ DO OPONENTE!");
                }
            } else if (ganhadorRodada == 2) {
                if (id) {
                    this.minhaVez = false;
                    this.jLabel13.setText("É A VEZ DO OPONENTE!");
                } else {
                    this.minhaVez = true;
                    this.jLabel13.setText("É A SUA VEZ!");
                }
            } else {
                //this.minhaVez = !this.minhaVez;
                if (this.minhaVez) {
                    this.jLabel13.setText("É A SUA VEZ!");
                } else {
                    this.jLabel13.setText("É A VEZ DO OPONENTE!");
                }
            }

            for (int i = 0; i < this.baralho.size(); i++) {
                if (this.carta1.equals(this.baralho.get(i).getNomeCarta())) {
                    this.baralho.get(i).mudaPosicao(this.n_y1);
                    this.n_y1++;
                }
                if (this.carta2.equals(this.baralho.get(i).getNomeCarta())) {
                    this.baralho.get(i).mudaPosicao(this.n_y1);
                    this.n_y1++;
                }
            }
            ((Mesa) this.jPMesa).repaint();

        } catch (Exception e) {
            System.err.println("ERRO AO ATUALIZAR O PLACAR");
        }
    }

    public void terminarPartida(int ganhadorPart, int placar, boolean id) {

        if (id && ganhadorPart == 1) {
            this.PontoJogador_truco = placar;
        } else if (!id && ganhadorPart == 2) {
            this.PontoJogador_truco = placar;
        }

        this.n_y1 = 0;

        if (this.PontoJogador_truco < 11) {
            this.jTrucar.setEnabled(true);
        }

        //try {
        this.jLabel13.setText(null);
        if (id) {
            if (ganhadorPart == 1) {
                JOptionPane.showMessageDialog(rootPane, "Você ganhou esta partida");
            } else {
                JOptionPane.showMessageDialog(rootPane, "Você perdeu esta partida");
            }
        }
        if (!id) {
            if (ganhadorPart == 1) {
                JOptionPane.showMessageDialog(rootPane, "Você perdeu esta partida");
            } else {
                JOptionPane.showMessageDialog(rootPane, "Você ganhou esta partida");
            }
        }
        jLabel10.setText(null);
        jLabel11.setText(null);
        jLabel12.setText(null);

        //this.PontoJogador_truco = 0;
        switch (ganhadorPart) {

            case 1:
                jLabel4.setText("" + placar);
                break;

            case 2:
                jLabel5.setText("" + placar);
                break;
        }
        //reiniciar partida
        Mensagem nova = new Mensagem(300, "");
        this.jt.enviarMensagem(nova);

    }

    public void finalizarJogo(int ganhadorPart, int placar, boolean id) {


        jLabel13.setText(null);
        if (id) {
            if (ganhadorPart == 1) {
                JOptionPane.showMessageDialog(rootPane, "Parabêns, você é o vencedor!!!");
            } else {
                JOptionPane.showMessageDialog(rootPane, "Que vergonha!!! você perdeu!!!");
            }
        }
        if (!id) {
            if (ganhadorPart == 1) {
                JOptionPane.showMessageDialog(rootPane, "Que vergonha!!! você perdeu!!!");
            } else {
                JOptionPane.showMessageDialog(rootPane, "Parabêns, você é o vencedor!!!");
            }
        }

        this.baralho.clear();

        jLabel10.setText(null);
        jLabel11.setText(null);
        jLabel12.setText(null);
        jLabel4.setText("0");
        jLabel5.setText("0");
        this.n_y1 = 0;

        this.PontoJogador_truco = 0;
        switch (ganhadorPart) {

            case 1:

                break;

            case 2:

                break;
        }
        ((Mesa) this.jPMesa).repaint();

        int i = 0;
        Object[] options2 = {"SIM", "NÃO"};
        i = JOptionPane.showOptionDialog(rootPane, "COMEÇAR UM NOVO JOGO? ", "AUMENTAR APOSTA", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE,
                null, options2, options2[0]);

        if (i == 0) {

            this.jTrucar.setEnabled(true);
            Mensagem nova = new Mensagem(300, "");
            this.jt.enviarMensagem(nova);
        }else{
            Mensagem nova = new Mensagem(20, "");
            this.jt.enviarMensagem(nova);
            this.jt.desconectar();
            this.servEsp.interrupt();
        }
    }

    public void oponenteNegou(){
        JOptionPane.showMessageDialog(rootPane, "O OPONENTE NÃO QUER CONTINUAR, FECHANDO CONEXÃO");
        this.servEsp.interrupt();
        this.jt.desconectar();
    }

    public boolean getminhavez() {
        return this.minhaVez;
    }

    public void esperando() {
        this.jLabel13.setText("ESPERANDO O OPONENTE SE CONECTAR!");
    }

    /*************************************************************************************
     *************************************************************************************
     ******    PARTE ONDE A CLASE PRINCIPAL INTERAGE COM A CLASSE SERVIDORTHREAD    ******
     *************************************************************************************
     *************************************************************************************/
    public void comparar(String carta, boolean idJogador) {
        if (idJogador) {
            this.Comparar.setCarta1(carta);


        } else {
            this.Comparar.setCarta2(carta);


        } // verificar se ja possui duas cartas para comparaçao
        if (!this.executado) {
            this.executado = true;


        } else if (this.executado) {
            this.executado = false;


            this.Comparar.cacularCarta(0);


            this.plac.setRodada(this.Comparar.getCalculaCarta());


        }
    }

    //Caso houver empate na terceira rodada, o desempate é feita pelo naipe
    public void calculoNaipe() {
        this.Comparar.cacularCarta(1);


        this.plac.setRodada(this.Comparar.getCalculaCarta());


    }

    public boolean getNaoPermitirRodada() {
        return this.plac.getcomparaPlacar();


    }

    //retorna true quando tem apenas uma carta, retorna false quando tem duas cartas para comparar
    public boolean getExecutado() {
        return this.executado;


    }

    public boolean getEnviar() {
        return this.enviar;


    }

    public void setEnviar(boolean enviar) {
        this.enviar = enviar;


    }

    public int retornarResultado() {
        return this.plac.getResultadoRodada(this.plac.getRodada());


    }

    public int getRodada() {
        return this.plac.getRodada();


    }

    public int getGanhador() {
        return this.plac.getGanhadorPartida();


    }

    public int getPlacar() {
        if (this.plac.getGanhadorPartida() == 1) {
            return this.plac.getPlacarJogador1();
        } else {
            return this.plac.getPlacarJogador2();
        }
    }

    public void enviarManilhaComparador(String manilha) {
        this.Comparar.setManilha(manilha);


    }

    public int getValorTruco() {
        return this.plac.getValorTruco();


    }

    public void podeApostar(int aposta, boolean idJogador) {
        this.plac.setAposta(aposta, idJogador);


    }

    public boolean correr() {
        return this.plac.getCorrer();
    }

    public void setarVariaveis() {
        if (!this.executado) {
            this.plac.setarcomparaPlacar();


            this.Comparar.CriarTabela();


        } else {
            this.executado = false;


        }
    }

    public void desconectar2() {
        JOptionPane.showMessageDialog(rootPane, "O OPONENTE SE DESCONECTOU!", "Desconectar", JOptionPane.INFORMATION_MESSAGE);
        jLabel3.setText("Jogador 1");
        jLabel6.setText("Jogador 2");
        jLabel4.setText("0");
        jLabel5.setText("0");


        this.baralho.clear();


        ((Mesa) this.jPMesa).repaint();

    }
}
