/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jogo;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;

public class EsperaConexao extends Thread {

    private int porta;
    private Principal pai;
    private boolean continua;
    private ArrayList<Mensagem> mensagem;
    private Thread t;

    public EsperaConexao(Principal pai, int porta) {
        this.porta = porta;
        this.pai = pai;
        this.mensagem = new ArrayList<Mensagem>();
        this.continua = true;

    }

    public boolean getContinua() {
        return continua;
    }

    @Override
    public void run() {
        try {

            ServerSocket servidor = new ServerSocket(porta, 2);

            ArrayList<ObjectOutputStream> jogadores = new ArrayList<ObjectOutputStream>();


            while (continua) {

                Socket conexao = servidor.accept();

                if (jogadores.size() < 2) {
                    System.err.println("EsperaConexao, jogador: "+jogadores.size());
                    this.t = new ServidorThread(this.pai,conexao, this.mensagem, jogadores);
                    this.t.start();
                } else {
                    System.err.println("Fluxo Bloqueado!");
                    continua = false;
                }



            }

        } catch (IOException ex) {
            System.err.println("erro na EsperaConexao " + ex.toString());
        }

    }
}